IF EXISTS (SELECT * FROM dbo.SysObjects WHERE id = object_id(N'dbo.AUDIT_upd_OTAAvailNotifLog') AND OBJECTPROPERTY(id, N'IsTrigger') = 1) DROP TRIGGER dbo.AUDIT_upd_OTAAvailNotifLog 
GO
CREATE TRIGGER [dbo].[AUDIT_upd_OTAAvailNotifLog]
ON [dbo].[OTAAvailNotifLog] FOR UPDATE NOT FOR REPLICATION AS
BEGIN
	

	DECLARE 
		@IDENTITY_SAVE			varchar(50),
		@AUDIT_LOG_TRANSACTION_ID	Int,
		@PRIM_KEY			nvarchar(4000),
		@Inserted	    		bit,
 		@ROWS_COUNT				int,
		@FK_UserIdNumber INT,
		@FK_CashBox INT,
		@ProgramPart SMALLINT,
		@TerminalName VARCHAR(50),
		@SystemDateStr VARCHAR(8),
		@SystemDateTime DATETIME

	SET NOCOUNT ON

	Select @ROWS_COUNT=count(*) from inserted
	SET @IDENTITY_SAVE = CAST(IsNull(@@IDENTITY,1) AS varchar(50))

    SELECT TOP 1 @FK_UserIdNumber = FK_UserIdNumber,
	@FK_CashBox = FK_CashBox,
	@ProgramPart = ProgramPart,
	@TerminalName = TerminalName
	FROM PersonnelLogInfo WITH (NOLOCK)
	WHERE spid = @@spid 
	ORDER BY CreateDate DESC

	IF ISNULL(@FK_UserIdNumber, 0) = 0
	  SET @FK_UserIdNumber = 1
	IF ISNULL(@FK_CashBox, -1) <= 0
	  SET @FK_CashBox = -1
	IF ISNULL(@ProgramPart, -1) <= 0
	  SET @ProgramPart = 14 -- ppUnknown from SystemAll
	IF ISNULL(@TerminalName, '') = ''
	  SET @TerminalName = 'Unknown'

    SELECT @SystemDateStr = SystemDate FROM System WITH (NOLOCK) WHERE Number = 1
    SET @SystemDateTime = CONVERT(DATETIME, @SystemDateStr + ' ' + CONVERT(CHAR(8), CURRENT_TIMESTAMP, 108))

	INSERT INTO dbo.AUDIT_LOG_TRANSACTIONS
	(
		TABLE_NAME,
		TABLE_SCHEMA,
		AUDIT_ACTION_ID,
		HOST_NAME,
		APP_NAME,
		MODIFIED_BY,
		MODIFIED_DATE,
		AFFECTED_ROWS,
		FK_UserIdNumber,
		FK_CashBox,
		ProgramPart,
		TerminalName,
		RealDateTime
	)
	values(
		'OTAAvailNotifLog',
		'dbo',
		1,	--	ACTION ID For UPDATE
		CASE 
		  WHEN LEN(HOST_NAME()) < 1 THEN ' '
		  ELSE HOST_NAME()
		END,
		CASE 
		  WHEN LEN(APP_NAME()) < 1 THEN ' '
		  ELSE APP_NAME()
		END,
		SUSER_SNAME(),
		@SystemDateTime,
		@ROWS_COUNT,
		@FK_UserIdNumber,
		@FK_CashBox,
		@ProgramPart,
		@TerminalName,
		GETDATE()
	)	
	
	Set @AUDIT_LOG_TRANSACTION_ID = SCOPE_IDENTITY()
	
	SET @Inserted = 0
	
	If UPDATE([RestrictionType])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3, KEY4
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')+' AND '+IsNull('[FKRateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelChannelId], NEW.[FKRateLevelChannelId]), 0), '[FKRateLevelChannelId] Is Null')+' AND '+IsNull('[FKRateLevelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelId], NEW.[FKRateLevelId]), 0), '[FKRateLevelId] Is Null')+' AND '+IsNull('[FKRoomTypeNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRoomTypeNumber], NEW.[FKRoomTypeNumber]), 0), '[FKRoomTypeNumber] Is Null')+' AND '+IsNull('[FKProductNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKProductNumber], NEW.[FKProductNumber]), 0), '[FKProductNumber] Is Null')),
		    'RestrictionType',
			CONVERT(nvarchar(4000), OLD.[RestrictionType], 0),
			CONVERT(nvarchar(4000), NEW.[RestrictionType], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0) or (NEW.[FKRateLevelChannelId] Is Null and OLD.[FKRateLevelChannelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0) or (NEW.[FKRateLevelId] Is Null and OLD.[FKRateLevelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0) or (NEW.[FKRoomTypeNumber] Is Null and OLD.[FKRoomTypeNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKProductNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKProductNumber], 0) or (NEW.[FKProductNumber] Is Null and OLD.[FKProductNumber] Is Null))
			where (
			
			
				(
					NEW.[RestrictionType] <>
					OLD.[RestrictionType]
				) Or
			
				(
					NEW.[RestrictionType] Is Null And
					OLD.[RestrictionType] Is Not Null
				) Or
				(
					NEW.[RestrictionType] Is Not Null And
					OLD.[RestrictionType] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([RestrictionLength])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3, KEY4
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')+' AND '+IsNull('[FKRateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelChannelId], NEW.[FKRateLevelChannelId]), 0), '[FKRateLevelChannelId] Is Null')+' AND '+IsNull('[FKRateLevelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelId], NEW.[FKRateLevelId]), 0), '[FKRateLevelId] Is Null')+' AND '+IsNull('[FKRoomTypeNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRoomTypeNumber], NEW.[FKRoomTypeNumber]), 0), '[FKRoomTypeNumber] Is Null')+' AND '+IsNull('[FKProductNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKProductNumber], NEW.[FKProductNumber]), 0), '[FKProductNumber] Is Null')),
		    'RestrictionLength',
			CONVERT(nvarchar(4000), OLD.[RestrictionLength], 0),
			CONVERT(nvarchar(4000), NEW.[RestrictionLength], 0),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0) or (NEW.[FKRateLevelChannelId] Is Null and OLD.[FKRateLevelChannelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0) or (NEW.[FKRateLevelId] Is Null and OLD.[FKRateLevelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0) or (NEW.[FKRoomTypeNumber] Is Null and OLD.[FKRoomTypeNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKProductNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKProductNumber], 0) or (NEW.[FKProductNumber] Is Null and OLD.[FKProductNumber] Is Null))
			where (
			
			
				(
					NEW.[RestrictionLength] <>
					OLD.[RestrictionLength]
				) Or
			
				(
					NEW.[RestrictionLength] Is Null And
					OLD.[RestrictionLength] Is Not Null
				) Or
				(
					NEW.[RestrictionLength] Is Not Null And
					OLD.[RestrictionLength] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	If UPDATE([SubmitDateStamp])
	BEGIN
    
		INSERT
		INTO dbo.AUDIT_LOG_DATA
		(
			AUDIT_LOG_TRANSACTION_ID,
			PRIMARY_KEY_DATA,
			COL_NAME,
			OLD_VALUE_LONG,
			NEW_VALUE_LONG,
			DATA_TYPE
			, KEY1, KEY2, KEY3, KEY4
		)
		SELECT
			@AUDIT_LOG_TRANSACTION_ID,
		    convert(nvarchar(1500), IsNull('[DateStamp]=N'''+replace(CONVERT(nvarchar(4000), IsNull(OLD.[DateStamp], NEW.[DateStamp]), 121),'''' ,'''''')+'''', '[DateStamp] Is Null')+' AND '+IsNull('[FKRateLevelChannelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelChannelId], NEW.[FKRateLevelChannelId]), 0), '[FKRateLevelChannelId] Is Null')+' AND '+IsNull('[FKRateLevelId]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRateLevelId], NEW.[FKRateLevelId]), 0), '[FKRateLevelId] Is Null')+' AND '+IsNull('[FKRoomTypeNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKRoomTypeNumber], NEW.[FKRoomTypeNumber]), 0), '[FKRoomTypeNumber] Is Null')+' AND '+IsNull('[FKProductNumber]='+CONVERT(nvarchar(4000), IsNull(OLD.[FKProductNumber], NEW.[FKProductNumber]), 0), '[FKProductNumber] Is Null')),
		    'SubmitDateStamp',
			CONVERT(nvarchar(4000), OLD.[SubmitDateStamp], 121),
			CONVERT(nvarchar(4000), NEW.[SubmitDateStamp], 121),
			'A'
			, IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[DateStamp], 121)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[DateStamp], 121))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0))), IsNULL( CONVERT(nvarchar(500), CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0)), CONVERT(nvarchar(500), CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)))
			
		FROM deleted OLD Inner Join inserted NEW On 
			(CONVERT(nvarchar(4000), NEW.[DateStamp], 121)=CONVERT(nvarchar(4000), OLD.[DateStamp], 121) or (NEW.[DateStamp] Is Null and OLD.[DateStamp] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelChannelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelChannelId], 0) or (NEW.[FKRateLevelChannelId] Is Null and OLD.[FKRateLevelChannelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRateLevelId], 0)=CONVERT(nvarchar(4000), OLD.[FKRateLevelId], 0) or (NEW.[FKRateLevelId] Is Null and OLD.[FKRateLevelId] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKRoomTypeNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKRoomTypeNumber], 0) or (NEW.[FKRoomTypeNumber] Is Null and OLD.[FKRoomTypeNumber] Is Null)) AND (CONVERT(nvarchar(4000), NEW.[FKProductNumber], 0)=CONVERT(nvarchar(4000), OLD.[FKProductNumber], 0) or (NEW.[FKProductNumber] Is Null and OLD.[FKProductNumber] Is Null))
			where (
			
			
				(
					NEW.[SubmitDateStamp] <>
					OLD.[SubmitDateStamp]
				) Or
			
				(
					NEW.[SubmitDateStamp] Is Null And
					OLD.[SubmitDateStamp] Is Not Null
				) Or
				(
					NEW.[SubmitDateStamp] Is Not Null And
					OLD.[SubmitDateStamp] Is Null
				)
				)
        
		SET @Inserted = CASE WHEN @@ROWCOUNT > 0 Then 1 Else @Inserted End
	END
	
	-- Watch
	
	-- Lookup
	
	IF @Inserted = 0
	BEGIN
		DELETE FROM dbo.AUDIT_LOG_TRANSACTIONS WHERE AUDIT_LOG_TRANSACTION_ID = @AUDIT_LOG_TRANSACTION_ID
	END
	-- Restore @@IDENTITY Value  
    DECLARE @maxprec AS varchar(2)
    SET @maxprec=CAST(@@MAX_PRECISION as varchar(2))
    EXEC('SELECT IDENTITY(decimal('+@maxprec+',0),'+@IDENTITY_SAVE+',1) id INTO #tmp')
End
